
ship=class()

function ship:init()
    self.cameraX=-195
    self.cameraY=1
    self.cameraZ=-195
    self.speed=0
    self.ang=0
    self.ex=0
    self.ey=45
    self.ez=0
    self.ships=4
    self.gyOrig=0
end

function ship:draw()
    pushMatrix()
    translate(WIDTH/2,HEIGHT/2-100)
    rotate(self.ang*-30)
    sprite(asset.builtin.Tyrian_Remastered.Boss_A,0,0,300)
    fill(0,255,0)
    text(gb.number,0,0)
    text(string.format("%.1f",self.cameraY),0,40)
    if mn.flying=="On" then
        text(string.format("%.1f",self.cameraY),0,40)
        stroke(255)
        strokeWidth(2)
        line(-80,20,-50,20)
        line(50,20,80,20)
        line(-50,20+self.ex*3,50,20+self.ex*3)
    end
    translate()
    popMatrix()
    fill(255)
    if self.speed==0 then
        text("Tap screen to start.",WIDTH/2,HEIGHT*.75)
    end
end

function ship:updateCamera()
    self.ey=self.ey-self.ang
    local x=self.speed*math.sin(math.rad(self.ey))
    local z=self.speed*math.cos(math.rad(self.ey))
    self.cameraX=self.cameraX+x
    self.cameraZ=self.cameraZ+z


end

function ship:tilt()
    gx=Gravity.x
    self.ang=self.ang+(gx-sc.hgx)*4
    sc.hgx=gx
    if gx>-.001 and gx<.001 then
        self.ang=0
    end    
    if sc.pct<=0 then
        self.cameraY=self.cameraY-.1
        self.ex=self.ex+.1
    else
        if mn.flying=="On" then
            gy=Gravity.y
            diff=self.gyOrig-gy
            self.ex=diff*-200
            if self.cameraY<1.5 and (self.gyOrig-gy)<0 then
                self.cameraY=self.cameraY+(self.gyOrig-gy)*.2
            else
                self.cameraY=self.cameraY+(self.gyOrig-gy)*2
            end
        end
    end
    if self.cameraY>40 then
        self.cameraY=40
    elseif self.cameraY<.5 then
        sound(SOUND_BLIT, 41088)
        if self.cameraY<=0 then
            self.cameraY=1
            sound(SOUND_EXPLODE, 20445)
            sc.hitWall=true
        end
    end
end

function ship:levels()
    for z=1,self.ships do
        sprite(asset.builtin.Tyrian_Remastered.Boss_A,z*50,HEIGHT-30,40)
    end
end
