ReorientableTiltControls = class()

function 
ReorientableTiltControls:init()
    self.baseGyro=0
end

function ReorientableTiltControls:reorient()
    self.baseGyro = Gravity.y
end

function ReorientableTiltControls:tilt()
    gx=Gravity.x
    self.ang=self.ang+(gx-sc.hgx)*4
    sc.hgx=gx
    if gx>-.001 and gx<.001 then
        self.ang=0
    end    
    if sc.pct<=0 then
        self.cameraY=self.cameraY-.1
        self.ex=self.ex+.1
    else
        if mn.flying=="On" then
            gy=Gravity.y
            diff=self.gyOrig-gy
            self.ex=diff*-200
            if self.cameraY<1.5 and (self.gyOrig-gy)<0 then
                self.cameraY=self.cameraY+(self.gyOrig-gy)*.2
            else
                self.cameraY=self.cameraY+(self.gyOrig-gy)*2
            end
        end
    end
    if self.cameraY>40 then
        self.cameraY=40
    elseif self.cameraY<.5 then
        sound(SOUND_BLIT, 41088)
        if self.cameraY<=0 then
            self.cameraY=1
            sound(SOUND_EXPLODE, 20445)
            sc.hitWall=true
        end
    end
end
